package com.zhongshu.card.server.core.dao.devices.impl;

import com.github.microservice.components.data.mongo.mongo.helper.DBHelper;
import com.zhongshu.card.client.model.devices.GateWayInfoSearch;
import com.zhongshu.card.server.core.dao.BaseImpl;
import com.zhongshu.card.server.core.dao.devices.extend.GateWayInfoDaoExtend;
import com.zhongshu.card.server.core.domain.school.Area;
import com.zhongshu.card.server.core.domain.devices.GateWayInfo;
import com.zhongshu.card.server.core.util.CommonUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

/**
 * @Author TRX
 * @CreateDate: 2023/4/12
 * @Version: 1.0
 */
public class GateWayInfoDaoImpl extends BaseImpl implements GateWayInfoDaoExtend {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Autowired
    private DBHelper dbHelper;

    @Override
    public Page<GateWayInfo> page(Pageable pageable, GateWayInfoSearch param) {
        Criteria criteria = buildCriteria(param);

        if (param.getState() != null) {
            criteria.and("state").is(param.getState());
        }

        if (StringUtils.isNotEmpty(param.getAreaId())) {
            criteria.and("area").is(Area.build(param.getAreaId()));
        }

        if (StringUtils.isNotEmpty(param.getProjectInfoCode())) {
            criteria.and("projectInfoCode").is(param.getProjectInfoCode());
        }

        if (!CommonUtil.longIsEmpty(param.getStartTime()) && !CommonUtil.longIsEmpty(param.getEndTime())) {
            criteria.and("createTime").gte(param.getStartTime()).and("createTime").lte(param.getEndTime());
        }

        // 模糊搜索
        List<Criteria> criterias = new ArrayList<>();
        if (StringUtils.isNotEmpty(param.getGateWayId())) {
            Pattern pattern = Pattern.compile("^.*" + param.getGateWayId() + ".*$");
            criterias.add(Criteria.where("gateWayId").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getGateWayName())) {
            Pattern pattern = Pattern.compile("^.*" + param.getGateWayName() + ".*$");
            criterias.add(Criteria.where("gateWayName").is(pattern));
        }

        if (StringUtils.isNotEmpty(param.getIp())) {
            Pattern pattern = Pattern.compile("^.*" + param.getIp() + ".*$");
            criterias.add(Criteria.where("ip").is(pattern));
        }
        if (!CollectionUtils.isEmpty(criterias)) {
            criteria.andOperator(criterias.toArray(new Criteria[]{}));
        }

        if (StringUtils.isNotEmpty(param.getKeyWord())) {
            Pattern pattern = Pattern.compile("^.*" + param.getKeyWord() + ".*$");
            criteria.orOperator(
                    Criteria.where("gateWayId").regex(pattern),
                    Criteria.where("gateWayName").regex(pattern),
                    Criteria.where("ip").regex(pattern)
            );
        }

        Sort sort = buildSort(param);
        Query query = Query.query(criteria);
        query.with(sort);
        return dbHelper.pages(query, pageable, GateWayInfo.class);
    }

}
